; $Id: dave.pro,v 1.55.4.2 2002/09/17 17:21:34 azuah Exp $
; DAVE.PRO
;
;
; Data Analysis and Visualization Environment
; Version 0.01
;
; Notes for use:
; Must use batchfile called davebatch.pro in startup file so that
; proper directory structure is known.
;
; Written by R.M.Dimeo (10/22/01)
;=================================
; Modified (11/02/01) to include CNRF png file for display
; on first screen (RMD)
; 
; Testing out CVS branching with this comment, this should
; only be in the stable branch and not the devel branch
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro daveCleanup,tlb
temp = ptr_valid(count=nptr)
print,'Number of dangling pointers: ',nptr
;print,'Freeing up the dangling pointers....'
ptr_free,ptr_valid()
temp = ptr_valid(count=nptr)
print,'Number of pointers left after cleanup: ',nptr
;if nptr eq 0 then print,'...pointers freed'

; If in the development environment, and running Windows,
; restore the launchtime current directory.
if (not lmgr(/runtime) and !version.os_family eq "Windows") then cd,!thisDir
;
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveQuit,event
widget_control,event.top,/destroy
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveAboutDave,event
aboutDave,group_leader = event.top
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function dave_defs_checkout,dave_defs
; These are the tag names that we currently expect to find in the structure
; "dave_defs". If there is any mismatch we proceed as though "dave_defs.sav"
; was not found.
tags_expected=strupcase(["datDir","workDir","PDFReader"])
tags_expected=tags_expected[sort(tags_expected)]
tags_found=strupcase(tag_names(dave_defs))
tags_found=tags_found[sort(tags_found)]
mismatch=n_elements(tags_found) ne n_elements(tags_expected)
if (not mismatch) then begin
	mismatch=total(tags_found eq tags_expected) lt n_elements(tags_found)
endif
if (mismatch) then x=dialog_message([$
	"Mismatch of tags",$
	"Found:   "+strjoin(tags_found,";"),$
	"Expected:"+strjoin(tags_expected,";")],/error)
return,mismatch
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;pro fdaveSelCurrentDirectory,event
;daveDeSensitizeButtons,event
;cd,current=curDir
;directory = DIALOG_PICKFILE(title = 'Select new current directory',/directory)
;if (directory ne '' and directory ne ' ') then begin
;	cd,directory
;	mismatch=1
;	if (file_test(!defaults_file)) then begin
;		restore,!defaults_file
;		dave_defs=*pdd
;		mismatch=dave_defs_checkout(dave_defs)
;	endif
;	if (mismatch) then begin
;		if (ptr_valid(pdd)) then ptr_free,pdd
;		pdd=ptr_new({datDir:directory,workDir:directory,PDFReader:''})
;	endif
;	defsysv,'!dave_defaults',pdd
;endif
;cd,current=newcurDir
;if (curDir ne newcurDir) then $
;	x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
;		"The working directory is "+(*!dave_defaults).workDir,"",$
;		"The current directory is "+newcurDir],/information)
;daveSensitizeButtons,event
;return
;end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSelDataDirectory,event
daveDeSensitizeButtons,event
dave_defs=*!dave_defaults
old_directory=dave_defs.datDir
directory = DIALOG_PICKFILE(title = 'Select data directory',/directory,path=old_directory)
if (directory eq '' or directory eq ' ') then begin
  daveSensitizeButtons,event
  return
endif
dave_defs.datDir=directory
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
cd,current=curDir
if (old_directory ne directory) then $
	x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
		"The working directory is "+(*!dave_defaults).workDir],$
		/information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSelWorkDirectory,event
daveDeSensitizeButtons,event
dave_defs=*!dave_defaults
old_directory=dave_defs.workDir
directory = DIALOG_PICKFILE(title = 'Select working directory',/directory,path=old_directory)
if (directory eq '' or directory eq ' ') then begin
  daveSensitizeButtons,event
  return
endif
dave_defs.workDir=directory
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
cd,current=curDir
if (old_directory ne directory) then $
	x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
		"The working directory is "+(*!dave_defaults).workDir],$
		/information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveDisplayDirectories,event
daveDeSensitizeButtons,event
;cd,current=curDir
x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
	"The working directory is "+(*!dave_defaults).workDir],$
        /information)
;	"The current directory is "+curDir],/information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSELpdfreader,event

dave_defs=*!dave_defaults
PDFReader=dave_defs.PDFReader
;print,"Current pdfreader is ",PDFReader

; check and then exit if reader's selected reader is okay
readerNotOkay = 'Yes'
if (strtrim(PDFReader,2) ne '') then begin
    message_text = ['Your PDF reader is currently set to:',PDFReader, $
                    'Are you sure you want to change this setting?']
    readerNotOkay = dialog_message(message_text,/question,/default_no, $
                                   title='PDF Reader Setting')
    readerBaseDir = strmid(PDFReader,0,strpos(PDFReader,!delimiter,/reverse_search))
endif
if (readerNotOkay eq 'No') then return ; nothing to do

; let user select select a reader
daveDeSensitizeButtons,event
if n_elements(event.top) gt 0 then begin
    acroread = dialog_pickfile(dialog_parent = event.top,/read, $
                               title="Please select your PDF reader", $
                               path=readerBaseDir, $
                               file = PDFReader)
endif else begin
    acroread = dialog_pickfile(/read, title="Please select your PDF reader", $
                               path=readerBaseDir, $
                               file = PDFReader)
endelse

if (acroread eq '' or acroread eq ' ') then begin
    daveSensitizeButtons,event
    return
endif
dave_defs.PDFReader=acroread
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
print,"New pdfreader is ",(*!dave_defaults).PDFReader
daveSensitizeButtons,event
return
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSwapDebugFlag, event

if (!debug) then $
  print,'!debug Old value: ',!debug

!debug = (!debug eq 0)? 1 : 0   ; switch !debug b/n 0 and 1

case !debug of                  ; set appropriate label
    0: widget_control, event.id, set_value='Switch on debug flag'
    1: widget_control, event.id, set_value='Switch off debug flag'
endcase

if (!debug) then $
  print,'!debug New value: ',!debug

end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro DCSreductionHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('DCSreductionHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('DCSreductionHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro hfbs_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('hfbsreduction.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro ToolsHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('ToolsHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('ToolsHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro DCSToolsHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('DCSToolsHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('DCSToolsHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro dave
; Widget definition module

;device,decomposed = 0
colorset
davesysvars

;
; If in the development environment, and running Windows,
; store the current directory.  Then make "C:\" the current directory.
if (not lmgr(/runtime) and !version.os_family eq "Windows") then begin
	cd,current=thisDir
	defsysv,'!thisDir',thisDir
	cd,"C:\"
endif

;
;
; No matter what, !dave_defaults is defined in the next few lines of code.
mismatch=1
if (file_test(!defaults_file)) then begin
	restore,!defaults_file
	dave_defs=*pdd
	mismatch=dave_defs_checkout(dave_defs)
endif
if (mismatch) then begin
	cd,current = thisDir
	pdd=ptr_new({datDir:thisDir,workDir:thisDir,PDFReader:''})
endif
defsysv,'!dave_defaults',pdd


filename = file_which('cnrf.png',/include_current_dir)
image = read_png(filename,r,g,b)
s = size(image)
sx = s[1] & sy = s[2]
aspect = 1.0*sy/sx		; find the aspect ratio of the image...
; ...and set the display window's dimensions based on this
; aspect ratio.
winxsize = 600 & winysize = fix(aspect*winxsize)

if (lmgr(/runtime)) then tlb_title = 'DAVE: Data Analysis and Visualization Environment' $
  else tlb_title = 'DAVE: Data Analysis and Visualization Environment - running under IDLDE'
tlb = widget_base(/row,tlb_frame_attr = 0,mbar = bar, title = tlb_title)
win = widget_draw(tlb,xsize = winxsize,ysize = winysize)
filemenu = widget_button(bar,value = 'File',/menu)
;void = widget_button(filemenu,value = 'Define current directory',$
;                     xsize = butsize,event_pro = 'fdaveSelCurrentDirectory')
void = widget_button(filemenu,value = 'Select raw data directory',$
                     xsize = butsize,event_pro = 'fdaveSelDataDirectory')
void = widget_button(filemenu,value = 'Select working directory',$
                     xsize = butsize,event_pro = 'fdaveSelWorkDirectory')
void = widget_button(filemenu,value = 'Display directories',$
                     xsize = butsize,event_pro = 'fdaveDisplayDirectories')
void = widget_button(filemenu,value = 'Select pdf reader',$
                     xsize = butsize,event_pro = 'fdaveSELpdfreader')
; debug flag widget should not appear in embedded version
if (not lmgr(/runtime)) then $
  void = widget_button(filemenu,value='Switch on debug flag',event_pro='fdaveSwapDebugFlag')
void = widget_button(filemenu,value = 'Exit',event_pro = 'fdaveQuit',$
                     xsize = butsize)

redMenu = widget_button(bar,value = 'Data Reduction',/menu)
dcsred = widget_button(redMenu,value = 'DCS',/menu)
void = widget_button(dcsRed,value = 'Reduce DCS raw data',$
         event_pro = 'DCSReduceRawData')
void = widget_button(dcsRed,value = 'Save DCS raw data in DAVE format',$
         event_pro = 'DCSSaveRawData_DAVE')
void = widget_button(dcsRed,value = 'Convert sqw_i files to DAVE format',$
         event_pro = 'DCSConvertSqwiFile_DAVE')
void = widget_button(dcsRed,value = 'Save DCS raw data in ascii format',$
         event_pro = 'DCSSave_ascii')
void = widget_button(dcsRed,value = 'Create DCS raw data summary file',$
         event_pro = 'DCSSummarize_ascii')
void = widget_button(dcsRed,value = 'Examine a DCS datafile',$
         event_pro = 'dave_examinedcsfiles')
void = widget_button(dcsRed,value = 'Plot DCS run information',$
         event_pro = 'DCS_runsinfo')
hfbsRed = widget_button(redMenu,value = 'HFBS',/menu)
void = widget_button(hfbsRed,value = 'Reduce .HFBS data',$
         event_pro = 'hfbs_RunReduce')
void = widget_button(hfbsRed,value = 'Reduce .HSCN data',$
         event_pro = 'hfbs_hscnReduce')
void = widget_button(hfbsRed,value = 'Convert DAVE to CON',$
         event_pro = 'hfbs_runCon')
void = widget_button(hfbsRed,value = 'Help on HFBS reduction',$
         event_pro = 'hfbs_help')
;nsered = widget_button(redMenu,value = 'NSE',/menu);,event_pro = 'fdaveRedNSE')
tasred = widget_button(redMenu,value = 'TAS',/menu);,event_pro = 'fdaveRedTAS')
; void = widget_button(tasRed,value = 'Reduce PSD data',$
;         event_pro = 'fdaveTAS', uvalue='PSD')
void = widget_button(tasRed,value = 'Reduce TAS data with TASXP',$
         event_pro = 'fdaveTAS', uvalue='XP')

fansRed = widget_button(redMenu,value = 'FANS',/menu)
void = widget_button(fansRed,value='Reduce FANS (*.bt4) data',event_pro='launchfansdatreduc')

asciiMenu = widget_button(redMenu,value = 'ASCII data',/menu)
threeColData = widget_button(asciiMenu,value = 'Read in x,y,yerr',$
                       event_pro = 'fdaveRead3ColAscii')

visMenu = widget_button(bar, value = 'Visualization', /menu)
twoDRen = widget_button(visMenu, value = 'Trifenestra (Three Windows)' $
	, event_pro = 'fdaveTAS', uvalue='PSD')
void = widget_button(visMenu,value = 'Simple image slicer',event_pro = 'daveLaunchIS')
void = widget_button(visMenu,value = 'Multiple dataset slicer',event_pro = 'launchdave_mdicer')

anMenu = widget_button(bar,value = 'Data Analysis',/menu)
panButton = widget_button(anMenu,value = 'Peak Analysis (PAN)',event_pro = 'fdaveLaunchPan')
fwsAnalysis = widget_button(anMenu,value = 'FWS Analysis (HFBS only)',event_pro = 'fdaveLaunchFWS')

toolsMenu = widget_button(bar,value = 'Tools',/menu)
genTools = widget_button(toolsMenu,value = 'General Tools',/menu)
void = widget_button(genTools,value = 'Self-shielding correction application',$
         event_pro = 'fdaveLaunchASC')
void = widget_button(genTools,value = 'Neutron calculator',$
         event_pro = 'fdaveLaunchNeutCalc')
void = widget_button(genTools,value = 'Points Digitizer (POD)',$
         event_pro = 'fdaveLaunchPOD')
void = widget_button(genTools,value = 'Examine a DAVE datafile',$
         event_pro = 'dave_examineDAVEfiles')
void = widget_button(genTools,value = 'View DAVE datafile treatment',$
         event_pro = 'dave_view_treatment')
void = widget_button(genTools,value = 'A look at the current DAVE structure',$
         event_pro = 'fdaveTAS', uvalue = 'EXAMINE')
void = widget_button(genTools,value = 'Save DAVE data in ascii format',$
         event_pro = 'dave_save_ascii')
void = widget_button(genTools,value = 'Create DAVE data summary file',$
         event_pro = 'dave_summarize_ascii')
void = widget_button(genTools,value = 'Rebin DAVE data file(s)',$
         event_pro = 'dave_rebindave')

rotor = widget_button(genTools,value = 'Hindered rotor calculators',/menu)
void = widget_button(rotor,value = 'Diatomic rigid rotor',$
		 event_pro = 'dave_rotor')
void = widget_button(rotor,value = 'Methyl rotor',$
		 event_pro = 'dave_mrotor')

dcsTools = widget_button(toolsMenu,value = 'DCS Tools',/menu)
void = widget_button(dcsTools,value = 'Generate constant energy width time channels',$
         event_pro = 'DCSToolsTchannels')
void = widget_button(dcsTools,value = 'Raw data sanity checks',$
         event_pro = 'DCSToolsSanitycheck')
void = widget_button(dcsTools,value = 'Experiment planner',$
         event_pro = 'DCSToolsPlanner')
void = widget_button(dcsTools,value = 'Chopper phase calculator',$
         event_pro = 'DCSToolsPhases')
void = widget_button(dcsTools,value = '"Revenge" calculator',$
         event_pro = 'DCSToolsRevenge')
void = widget_button(dcsTools,value = 'Intensity and resolution',$
         event_pro = 'DCSToolsPerformance')
void = widget_button(dcsTools,value = 'Detector information',$
         event_pro = 'DCSToolsDetectors')
void = widget_button(dcsTools,value = 'Rules of thumb',$
         event_pro = 'DCSToolsThumbrules')
hfbsTools = widget_button(toolsMenu,value = 'HFBS Tools',/menu)
void = widget_button(hfbsTools,value = 'Databrowser',event_pro = 'davelaunchhfbsdb')
;nseTools = widget_button(toolsMenu,value = 'Spin Echo Tools',/menu)
tasTools = widget_button(toolsMenu,value = 'TAS Tools',/menu)
void = widget_button(tasTools,value = 'Spurion calculator',event_pro = 'launchSpur')
fansTools = widget_button(toolsMenu,value = 'FANS Tools',/menu)
void = widget_button(fansTools,value = 'FANS Data Browser',event_pro = 'launchFansBrowser')
;void = widget_button(tasTools,value = 'Inelastic spurion calculator',event_pro = 'launchSpur2')
;funTools = widget_button(toolsMenu,value = 'Just for fun...',/menu)
;void = widget_button(funTools,value = 'Data-blaster',$
;         event_pro = 'fdaveLaunchDataBlaster')
miscMenu = widget_button(bar,value = 'Misc',/menu)
void = widget_button(miscMenu,value = 'About DAVE',$
         event_pro = 'fdaveAboutDave')
void = widget_button(miscMenu,value = 'Useful rules of thumb',$
         event_pro = 'dave_thumbrules')
;helpMenu = widget_button(bar,value = 'Help',/menu)
;void = widget_button(helpMenu,value = 'Help for DCS Data Reduction',$
;         event_pro = 'DCSReductionHelp')
;void = widget_button(helpMenu,value = 'Help for General Tools',$
;         event_pro = 'ToolsHelp')
;void = widget_button(helpMenu,value = 'Help for DCS Tools',$
;         event_pro = 'DCSToolsHelp')
; Center it all on the screen
centertlb,tlb

widget_control,tlb,/realize
widget_control,win,get_value = winVis
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix = !d.window

;wset,winPix
tvlct,r,g,b	; load the proper color tables as found in
; read_png above.
dispImage = congrid(image,winxsize,winysize)

wset,winPix
tvimage,dispImage
wset,winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,winPix]
wdelete,winPix
;
device,/cursor_original
commonStr = {instrument:'',$
             histPtr:ptr_new(/allocate_heap),$
             xlabel:'',$
             ylabel:'',$
             xtype:'',$
             ytype:'',$
             xunits: '',$
             yunits: '',$
             histLabel:'',$
             histUnits:'',$
             treatmentPtr:ptr_new(/allocate_heap),$
             commonStrPtr:ptr_new()}

dataStr = {commonStr:commonStr,$
           specificPtr:ptr_new(/allocate_heap)}

state =    {dataStrPtr:ptr_new(dataStr)}
pState = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pState,/no_copy

xmanager,'dave',tlb,cleanup = 'daveCleanup',/no_block

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
