; $Id: dave_position_tlb.pro,v 1.3 2002/07/08 20:42:32 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dave_position_tlb,tlb,ssize,center
;************************************************************************************************
; Centers a widget base at ssize*center. The screensize is ssize.
; The default value of center is [0.5,0.5]. If ssize is not specified the system variable
; !screensize is used.
;
compile_opt strictarr
;
case n_params(0) of
	1: begin
		cen = [0.5,0.5]
		scrsize = !screensize
	end
	2: begin
		cen = [0.5,0.5]
		scrsize = ssize
	end
	3: begin
		cen = center
		scrsize = ssize
	end
	else: return
endcase
;
; Size of widget.
geom=widget_info(tlb,/geometry)
wdgsize = [geom.xsize,geom.ysize]
;
; Top left and bottom right positions.
xytl = scrsize*cen-wdgsize*0.5
xybr = scrsize*cen+wdgsize*0.5
;
; Try to ensure that all of the widget is visible.
offset = (xybr < scrsize) - wdgsize
offset = (xytl > 0)
;
; Position the widget.
widget_control,tlb,tlb_set_xoffset=offset[0],tlb_set_yoffset=offset[1]
;
end