; $Id: imageSlicer.pro,v 1.13 2002/04/18 20:43:17 jmspark Exp $
; imageSlicer.pro
;
; Image slicing utility.
;
; USES:		XCOLORS.PRO
;			IS_GAUSSIAN.PRO
;			PSF_GAUSSIAN.PRO
;			DAVE_BEAST_OPS.PRO
;			CENTERTLB.PRO
;			CONVOLVE.PRO
;
;
; Modification history:
; --------------------
; 03/11/02 (RMD):	Reads in and displays DAVE files.
;
;;;;;;;;;;;;;;;;;;;;;;;;;
pro free_the_pointer,xPtr
if ptr_valid(xPtr) then ptr_free,xPtr
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro adjustWinSize,event
widget_control,event.top,get_uvalue = pState

widget_control,(*pState).plotWin1,draw_xsize = (*pState).winxsize,$
               draw_ysize = (*pState).winysize
widget_control,(*pState).plotWin2,draw_xsize = (*pState).winxsize,$
               draw_ysize = (*pState).winysize
widget_control,(*pState).plotWin3,draw_xsize = (*pState).winxsize,$
               draw_ysize = (*pState).winysize
widget_control,(*pState).plotWin4,draw_xsize = (*pState).winxsize,$
               draw_ysize = (*pState).winysize

wdelete,(*pState).winPix1
wdelete,(*pState).winPix2
wdelete,(*pState).winPix3
wdelete,(*pState).winPix4

window,/free,/pixmap,xsize = (*pState).winxsize,ysize = (*pState).winysize
(*pState).winPix1 = !d.window
window,/free,/pixmap,xsize = (*pState).winxsize,ysize = (*pState).winysize
(*pState).winPix2 = !d.window
window,/free,/pixmap,xsize = (*pState).winxsize,ysize = (*pState).winysize
(*pState).winPix3 = !d.window
window,/free,/pixmap,xsize = (*pState).winxsize,ysize = (*pState).winysize
(*pState).winPix4 = !d.window

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isGetDCSFile,event
widget_control,event.top,get_uvalue = pState
catch,anError
if anError ne 0 then begin
  catch,/cancel
  void = dialog_message('Error reading file')
  return
endif
filename = DIALOG_PICKFILE(dialog_parent = event.top,$
                                            title = 'Select DCS file to load',$
                                            /read,filter = '*.dcs.gz',$
                                            path = (*!dave_defaults).datdir)
if ((filename eq '') or (filename eq ' ')) then begin
    return
endif

dcs_sysvars
dave_makeDavePtr,davePtr=davePtr
dcs_definedavestructure,davePtr=davePtr
nofirstline=0
omithisto=0
printinfo=0
dcs_read_binaryOctavefile,filename,nofirstline,omithisto,variables_read,$
			unknowns,error,davePtr=davePtr
if (strlen(error) gt 0) then begin
	result=dialog_message(["Error reading binary file.","Exiting ..."])
	return
endif

state = *davePtr
ptr_free,davePtr

qty = (*(*state.dataStrPtr).commonStr.histPtr).qty
qtySize = size(qty)
(*pState).nchan = qtySize[1]
(*pState).ndet = qtySize[2]
qty = transpose(qty)

widget_control,(*pState).imageMax,set_value = string(max(qty))
widget_control,(*pState).imageMin,set_value = string(min(qty))
dave_beast_ops,'rem',state

dataSize = size(qty)
if dataSize[0] ne 2 then return

; Get out the parameters that we'll need for displaying
; the correct position and intensity in the data array after
; it has been "bytscaled."
(*pState).imax = max(qty)
(*pState).imin = min(qty)


nchan = dataSize[1]
ndet = dataSize[2]

file = FILEPATH(SUBDIR=['examples', 'data'], 'cereb.dat')
xsize = 512 & ysize = 512
aspect = 1.0*ysize/(1.0*xsize)
(*pState).winxsize = (*pState).winsize
(*pState).winysize = fix(aspect*(*pState).winxsize)
;widget_control,(*pState).attSlider,get_value = val
val = 255
data = qty	;bytscl(qty)
(*pState).xsize = xsize & (*pState).ysize = ysize

adjustWinSize,event

; Scale image size down to fit into a reasonable size plot window
(*pState).wx = 0.25*(*pState).winxsize
(*pState).wy = 0.25*(*pState).winysize

newdata = bytarr((*pState).winxsize,(*pState).winysize)
newdata = congrid(data,(*pState).winxsize,(*pState).winysize)
origData = newdata
data = bytarr((*pState).winxsize,(*pState).winysize)
data = newdata
data = bytscl(temporary(data))
(*pState).maxValue = 1.2*max(data)

wset,(*pState).winPix2
erase
tv,data,xsize = (*pState).xsize,$
   ysize = (*pState).ysize
wset,(*pState).winVis2
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]

*(*pState).dataPtr = data
*(*pState).origDataPtr = origData
widget_control,(*pState).xbins,set_value = 1
widget_control,(*pState).ybins,set_value = 1

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isStuffIt,event
widget_control,event.top,get_uvalue = pState

davePtr = (*pState).davePtr

state = *davePtr
workDir = (*!dave_defaults).workDir
datDir = (*!dave_defaults).datDir

qty = (*(*state.dataStrPtr).commonStr.histPtr).qty
qtySize = size(qty)
(*pState).nchan = qtySize[1]
(*pState).ndet = qtySize[2]
qty = transpose(qty)

widget_control,(*pState).imageMax,set_value = string(max(qty))
widget_control,(*pState).imageMin,set_value = string(min(qty))
;dave_beast_ops,'rem',state

dataSize = size(qty)
if dataSize[0] ne 2 then return

; Get out the parameters that we'll need for displaying
; the correct position and intensity in the data array after
; it has been "bytscaled."
(*pState).imax = max(qty)
(*pState).imin = min(qty)

xsize = 512 & ysize = 512
aspect = 1.0*ysize/(1.0*xsize)
(*pState).winxsize = (*pState).winsize
(*pState).winysize = fix(aspect*(*pState).winxsize)
val = 255
data = qty	;bytscl(qty)
(*pState).xsize = xsize & (*pState).ysize = ysize

adjustWinSize,event

; Scale image size down to fit into a reasonable size plot window
(*pState).wx = 0.25*(*pState).winxsize
(*pState).wy = 0.25*(*pState).winysize

newdata = bytarr((*pState).winxsize,(*pState).winysize)
newdata = congrid(data,(*pState).winxsize,(*pState).winysize)
origData = newdata
data = bytarr((*pState).winxsize,(*pState).winysize)
data = newdata
data = bytscl(temporary(data))
(*pState).maxValue = 1.2*max(data)

wset,(*pState).winPix2
erase
tv,data,xsize = (*pState).xsize,$
   ysize = (*pState).ysize
wset,(*pState).winVis2
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]

*(*pState).dataPtr = data
*(*pState).origDataPtr = origData
widget_control,(*pState).xbins,set_value = 1
widget_control,(*pState).ybins,set_value = 1

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isGetDaveFile,event
widget_control,event.top,get_uvalue = pState

catch,anError
if anError ne 0 then begin
  catch,/cancel
  void = dialog_message('Error reading file')
  return
endif
; Restore the dave file
filename = DIALOG_PICKFILE(dialog_parent = event.top,$
                                            title = 'Select DAVE file to load',$
                                            /read,filter = '*.dave',$
                                            path = (*!dave_defaults).workdir)
if ((filename eq '') or (filename eq ' ')) then begin
    return
endif

restore,filename
(*pState).davePtr = davePtr
isStuffIt,event

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerQuit,event
widget_control,event.top,/destroy
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerCleanup,tlb
widget_control,tlb,get_uvalue = pState
tvlct,(*pState).inColors.red,(*pState).inColors.green,(*pState).inColors.blue
!x.margin = [10,3]
!y.margin = [4,2]
isInfo = {isEvent,$
          id:(*pState).notifyIDs[0],$
          top:(*pState).notifyIDs[1],$
          handler:0L}
if widget_info((*pState).notifyIDs[0],/valid_id) then begin
  widget_control,(*pState).notifyIDs[0],send_event = isInfo
endif
wdelete,(*pState).winPix1
wdelete,(*pState).winPix2
wdelete,(*pState).winPix3
wdelete,(*pState).winPix4
ptr_free,(*pState).dataPtr
ptr_free,(*pState).origDataPtr
ptr_free,pState

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerPlotWin1,event
widget_control,event.top,get_uvalue = pState
wset,(*pState).winPix1
erase
xcut = fix((*pState).xp1)
plot,(*(*pState).dataPtr)[xcut,*],indgen((*pState).winysize),$
     yrange = [0.0,(*pState).winysize],color = (*pState).white,$
     ystyle = 5,xrange = [0.0,(*pState).maxValue],xstyle = 5
wset,(*pState).winVis1
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix1]

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isPrintOne,event
widget_control,event.top,get_uvalue = pState

thisDevice = !d.name
deviceKeywords = ps_form(Cancel = canceled,parent = event.top)
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = deviceKeywords
  xcut = fix((*pState).xp1)
  plot,(*(*pState).dataPtr)[xcut,*],indgen((*pState).winysize),$
       yrange = [0.0,(*pState).winysize],$
       ystyle = 5,xrange = [0.0,(*pState).maxValue],xstyle = 5

  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isPrintTwo,event
widget_control,event.top,get_uvalue = pState

thisDevice = !d.name
deviceKeywords = ps_form(Cancel = canceled,parent = event.top)
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = deviceKeywords
  tv,*(*pState).dataPtr
  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isPrintFour,event
widget_control,event.top,get_uvalue = pState

thisDevice = !d.name
deviceKeywords = ps_form(Cancel = canceled,parent = event.top)
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = deviceKeywords
  ycut = fix((*pState).yp1)
  plot,indgen((*pState).winxsize),(*(*pState).dataPtr)[*,ycut],$
     xrange = [0.0,(*pState).winxsize],$
     ystyle = 5,yrange = [0.0,(*pState).maxValue],xstyle = 5
  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isPrintThree,event
widget_control,event.top,get_uvalue = pState

thisDevice = !d.name
deviceKeywords = ps_form(Cancel = canceled,parent = event.top)
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = deviceKeywords


	xlo = (*pState).xp1-0.5*(*pState).wx
	xhi = (*pState).xp1+0.5*(*pState).wx
	ylo = (*pState).yp1-0.5*(*pState).wy
	yhi = (*pState).yp1+0.5*(*pState).wy
	if xlo le 0 or xhi ge (*pState).winxsize or $
   		ylo le 0 or yhi ge (*pState).winysize then begin
   		return
	endif
	tv,smooth(congrid((*(*pState).dataPtr)[xlo:xhi,ylo:yhi],$
          (*pState).winxsize,(*pState).winysize),3,/edge_truncate)

	plots,[0.0,(*pState).winxsize],fix(0.5*(*pState).winysize)*[1,1],/device,thick = 1.0
	plots,fix(0.5*(*pState).winxsize)*[1,1],[0.0,(*pState).winysize],/device,thick = 1.0


  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerPlotWin3,event
widget_control,event.top,get_uvalue = pState
wset,(*pState).winPix3
erase
ycut = fix((*pState).yp1)
plot,indgen((*pState).winxsize),(*(*pState).dataPtr)[*,ycut],$
     xrange = [0.0,(*pState).winxsize],color = (*pState).white,$
     ystyle = 5,yrange = [0.0,(*pState).maxValue],xstyle = 5
wset,(*pState).winVis3
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix3]
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerPlotWin2,event
widget_control,event.top,get_uvalue = pState
wset,(*pState).winPix2
erase
tv,*(*pState).dataPtr,xsize = (*pState).xsize,$
   ysize = (*pState).ysize
wset,(*pState).winVis2
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isUpdatePlots,event
widget_control,event.top,get_uvalue = pState
if n_elements(*(*pState).dataPtr) lt 2 then return

; First process the image
widget_control,(*pState).xbins,get_value = nxBins
nxBins = fix(nxBins[0])
widget_control,(*pState).ybins,get_value = nyBins
nyBins = fix(nyBins[0])

if (nxBins lt 1) or (nyBins lt 1) then begin
  void = dialog_message(dialog_parent = event.top,'# pixels must be greater than zero')
  return
endif

widget_control,(*pState).imageMax,get_value = imageMax
imageMax = float(imageMax[0])
widget_control,(*pState).imageMin,get_value = imageMin
imageMin = float(imageMin[0])
z = congrid(*(*pState).origDataPtr,(*pState).winxsize,(*pState).winysize)

; smooth z with a Gaussian point-spread-function
dataSize = size(z)
nx = dataSize[1]
ny = dataSize[2]
psf = psf_gaussian(NPIXEL=[nx,ny], FWHM=[nxBins,nyBins], /NORMALIZE, NDIMEN = 2)
zcon = convolve(z,psf)
z = zcon

; create the mask of values between imageMin and imageMax
mask = (z gt imageMin) and (z lt imageMax)
masklo = where(z gt imageMax)

; scale into the interval 0 to 255 so color get mapped properly
; The ceiling values are 255 and the floor values will are 0.
*(*pState).dataPtr = bytscl(z*mask)
if masklo[0] ne -1 then (*(*pState).dataPtr)[masklo] = 255
if (*pState).transFlag eq 1 then begin
  *(*pState).dataPtr = transpose(*(*pState).dataPtr)
endif

; Now display the resulting processed image
imageSlicerPlotWin1,event
imageSlicerPlotWin3,event
imageSlicerPlotWin4,event
imageSlicerPlotWin2,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isSliderEvent,event
widget_control,event.top,get_uvalue = pState
if n_elements(*(*pState).dataPtr) lt 2 then return

;widget_control,(*pState).attSlider,get_value = val
val = 255
;widget_control,(*pState).smSlider,get_value = smValue
;if smValue[0] lt 1 then begin
  *(*pState).dataPtr = bytscl(*(*pState).origDataPtr < val[0])
;endif else begin
;  *(*pState).dataPtr = smooth(bytscl(*(*pState).origDataPtr < val[0]),smValue[0] > 2,$
;                       /edge_truncate)
;endelse
imageSlicerPlotWin1,event
imageSlicerPlotWin3,event
imageSlicerPlotWin4,event
imageSlicerPlotWin2,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isSmSliderEvent,event
widget_control,event.top,get_uvalue = pState
if n_elements(*(*pState).dataPtr) lt 2 then return
val = 255
*(*pState).dataPtr = bytscl(*(*pState).origDataPtr < val[0])
imageSlicerPlotWin1,event
imageSlicerPlotWin3,event
imageSlicerPlotWin4,event
imageSlicerPlotWin2,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerPlotWin4,event
widget_control,event.top,get_uvalue = pState
; Here we magnify the image and display it
wset,(*pState).winPix4
erase
xlo = (*pState).xp1-0.5*(*pState).wx
xhi = (*pState).xp1+0.5*(*pState).wx
ylo = (*pState).yp1-0.5*(*pState).wy
yhi = (*pState).yp1+0.5*(*pState).wy
if xlo le 0 or xhi ge (*pState).winxsize or $
   ylo le 0 or yhi ge (*pState).winysize then begin
   return
endif
tv,smooth(congrid((*(*pState).dataPtr)[xlo:xhi,ylo:yhi],$
          (*pState).winxsize,(*pState).winysize),3,/edge_truncate),$
          xsize = (*pState).winxsize,ysize = (*pState).winysize
wset,(*pState).winVis4
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix4]
plots,[0.0,(*pState).winxsize],fix(0.5*(*pState).winysize)*[1,1],/device,thick = 1.0
plots,fix(0.5*(*pState).winxsize)*[1,1],[0.0,(*pState).winysize],/device,thick = 1.0
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicerwin2draw,event
widget_control,event.top,get_uvalue = pState
aspect = 1.0*!d.y_size/!d.x_size

case event.type of
0:  begin	; button press
	  widget_control,(*pState).plotWin2,draw_motion_events = 1
	  (*pState).mouse = event.press
	  if (*pState).mouse eq 1 then begin
	    (*pState).xp1 = event.x
	    (*pState).yp1 = event.y
	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event
	    wset,(*pState).winVis2
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]

	    empty
	  endif
	  if (*pState).mouse eq 4 and (*pState).cxpos eq -999 then begin
	    (*pState).cxpos = event.x
	    (*pState).cypos = event.y
	    (*pState).xp1 = event.x
	    (*pState).yp1 = event.y
	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event

	    wset,(*pState).winVis2
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]
	    empty
	  endif
	end

2:	begin	; mouse motion
	  if (*pState).mouse eq 1 then begin
	    widget_control,(*pState).plotWin2,draw_motion_events = 1
	    ; Test if cursor is out of the window boundary...if so then return
	    if event.x le 0 or event.x ge (*pState).winxsize or $
	       event.y le 0 or event.y ge (*pState).winysize then begin
	       (*pState).mouse = 0

	       return
	    endif
	    (*pState).xp1 = event.x
	    (*pState).yp1 = event.y
	    wset,(*pState).winVis2
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]
;	    tvlct,r,g,b,/get
;	    loadct,0,/silent
	    plots,[0.0,(*pState).winxsize],[event.y,event.y],/device,thick = 1.0,$
	    color = (*pState).white
	    plots,[event.x,event.x],[0.0,(*pState).winysize],/device,thick = 1.0,$
	    color = (*pState).white
	    ; Draw the box
	    plots,[event.x-0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	        [event.y-0.5*(*pState).wy,event.y-0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[event.x-0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	        [event.y+0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[event.x-0.5*(*pState).wx,event.x-0.5*(*pState).wx],$
	        [event.y-0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[event.x+0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	        [event.y-0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    color = (*pState).white
;		tvlct,r,g,b
	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event

	  endif
	  if (*pState).mouse eq 4 then begin
        widget_control,(*pState).plotWin2,draw_motion_events = 1
	    wset,(*pState).winVis2
	    device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix2]
	    ; draw the cross-hairs
	    plots,[0.0,(*pState).winxsize],[(*pState).cypos,(*pState).cypos],$
	          /device,thick = 1.0,$
	    color = (*pState).white
	    plots,[(*pState).cxpos,(*pState).cxpos],[0.0,(*pState).winysize],$
	          /device,thick = 1.0,$
	    color = (*pState).white
	    ; Draw the box
	    (*pState).wx = 2.0*abs(event.x-(*pState).cxpos)
	    (*pState).wy = fix(aspect*(*pState).wx)
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	        [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos-0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	        [(*pState).cypos+0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos-0.5*(*pState).wx],$
	        [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    color = (*pState).white
	    plots,[(*pState).cxpos+0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	        [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    color = (*pState).white

	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event

	  endif
	end

1:	begin	; button release
	  if (*pState).mouse eq 1 then begin

	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event
	    imageSlicerPlotWin2,event
        widget_control,(*pState).xpix,set_value = fix(event.x*(*pState).nchan/255.0)
        widget_control,(*pState).ypix,set_value = fix(event.y*(*pState).ndet/255.0)
        intensity = float((*(*pState).dataPtr)[event.x,event.y])
        ; Scale the intensity
        widget_control,(*pState).imageMin,get_value = imin & imin = float(imin[0])
        widget_control,(*pState).imageMax,get_value = imax & imax = float(imax[0])
        in = intensity*(imax-imin)/255.0
        widget_control,(*pState).ipix,set_value = in
	    plots,[0.0,(*pState).winxsize],[event.y,event.y],/device,thick = 1.0,$
	    		color = (*pState).white
	    plots,[event.x,event.x],[0.0,(*pState).winysize],/device,thick = 1.0,$
	   		 color = (*pState).white
	    ; Draw the zoom box
	    plots,[event.x-0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	          [event.y-0.5*(*pState).wy,event.y-0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[event.x-0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	          [event.y+0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[event.x-0.5*(*pState).wx,event.x-0.5*(*pState).wx],$
	          [event.y-0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[event.x+0.5*(*pState).wx,event.x+0.5*(*pState).wx],$
	          [event.y-0.5*(*pState).wy,event.y+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
;	    tvlct,r,g,b
	    (*pState).cxpos = event.x
	    (*pState).cypos = event.y
	    widget_control,(*pState).plotWin2,draw_motion_events = 0
	  endif
	  if (*pState).mouse eq 4 then begin

	    imageSlicerPlotWin1,event
	    imageSlicerPlotWin3,event
	    imageSlicerPlotWin4,event
	    imageSlicerPlotWin2,event
;		tvlct,r,g,b,/get
;		loadct,0,/silent
	    plots,[0.0,(*pState).winxsize],[(*pState).cypos,(*pState).cypos],$
	           /device,thick = 1.0,$
	    		color = (*pState).white
	    plots,[(*pState).cxpos,(*pState).cxpos],[0.0,(*pState).winysize],$
	           /device,thick = 1.0,$
	    		color = (*pState).white
	    ; Draw the zoom box
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	          [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos-0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	          [(*pState).cypos+0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[(*pState).cxpos-0.5*(*pState).wx,(*pState).cxpos-0.5*(*pState).wx],$
	          [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
	    plots,[(*pState).cxpos+0.5*(*pState).wx,(*pState).cxpos+0.5*(*pState).wx],$
	          [(*pState).cypos-0.5*(*pState).wy,(*pState).cypos+0.5*(*pState).wy],/device,$
	    		color = (*pState).white
;		tvlct,r,g,b
	    widget_control,(*pState).plotWin2,draw_motion_events = 0
	  endif
	  (*pState).mouse = 0
	end

else:
endcase


return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isChangeCT,event
widget_control,event.top,get_uvalue = pState
thisEvent = Tag_Names(event, /Structure_Name)
CASE thisEvent OF
	'WIDGET_BUTTON':	BEGIN
							XColors, Group_Leader=event.top, $
							         NotifyID=[event.id, event.top],$
							         title = 'Colors for Image Slicer'
					 	ENDCASE

    'XCOLORS_LOAD': 	BEGIN
                 			Device, Get_Visual_Depth=thisDepth
                 			IF thisDepth GT 8 THEN BEGIN
								if n_elements(*(*pState).dataPtr) lt 2 then return
								; Force white to be in entry 255 and use this
								; persistently for currently loaded color table.
								tvlct,255,255,255,255
								(*pState).white = 255

								isUpdatePlots,event
                 			ENDIF
                 		ENDCASE

ENDCASE

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro isTranspose,event
widget_control,event.top,get_uvalue = pState
if (*pState).transFlag eq 1 then begin
  (*pState).transFlag = 0
endif else begin
  (*pState).transFlag = 1
endelse
if n_elements(*(*pState).dataPtr) lt 2 then return
; Swap the order of nchan and ndet
nchan = (*pState).nchan
ndet = (*pState).ndet
(*pState).ndet = nchan
(*pState).nchan = ndet
isUpdatePlots,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicer_event,event
widget_control,event.top,get_uvalue = pState
isUpdatePlots,event
return
end
;;;;;;;;;;;;;;;;;;;
pro isAbout,event
strout = ['Image Slicer','Written by R.M.Dimeo',$
          'March 11, 2002',$
          'NIST Center for Neutron Research']
void = dialog_message(strout,/information,dialog_parent = event.top,$
       title = 'About Image Slicer')
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;
pro imageSlicer,group_leader = group_leader,notifyIDs = notifyIDs
; Get the DAVEPTR...
widget_control,group_leader,get_uvalue = davePtr
state = *davePtr
dataStr = *state.dataStrPtr
commonStr = dataStr.commonStr
histPtr = commonStr.histPtr

; Widget definition module
tvlct,red,green,blue,/get
inColors = {red:red,green:green,blue:blue}
device,decomposed = 0

loadct,5,/silent
winxsize = 250 & winysize = 250

; Test for input keywords
if n_elements(group_leader) eq 0 then begin
  tlb1 = widget_base(/col,title = 'Image Slicer',tlb_frame_attr = 1,mbar =  bar)
endif else begin
  tlb1 = widget_base(group_leader = group_leader,/col,title = 'Image Slicer',$
         tlb_frame_attr = 1,mbar =  bar)
endelse

if n_elements(notifyIDs) eq 0 then notifyIDs = [0L,0L]

tlb = widget_base(tlb1,/col)

ltlb = widget_base(tlb,/row)
filemenu = WIDGET_BUTTON(bar, value='File', /menu)
;selmenu = WIDGET_BUTTON(bar, value='Images', /menu)
colormenu = WIDGET_BUTTON(bar, value='Colors', /menu)
printmenu = WIDGET_BUTTON(bar, value='Print', /menu)
void = widget_button(printmenu,value = 'Print upper left panel',event_pro = 'isPrintOne')
void = widget_button(printmenu,value = 'Print upper right panel',event_pro = 'isPrintTwo')
void = widget_button(printmenu,value = 'Print lower left panel',event_pro = 'isPrintThree')
void = widget_button(printmenu,value = 'Print lower right panel',event_pro = 'isPrintFour')

void = widget_button(filemenu,value = 'Load DAVE file',event_pro = 'isGetDaveFile')
void = widget_button(filemenu,value = 'Load raw DCS file',event_pro = 'isGetDCSFile')
void = widget_button(filemenu,value = 'About Image Slicer',event_pro = 'isAbout')
;void = widget_button(selmenu,value = 'Brain X-Ray',event_pro = 'getCerebrum')
;void = widget_button(selmenu,value = 'Hurricane Gilbert',event_pro = 'getHurricane')
;void = widget_button(selmenu,value = 'Galaxy',event_pro = 'getGalaxy')
void = widget_button(colormenu,value = 'Select colors',event_pro = 'isChangeCT')
base1 = widget_base(ltlb,/col,/base_align_right)
base2 = widget_base(ltlb,/col,/base_align_right)

plotWin1 = widget_draw(base1,xsize = winxsize,ysize = winysize)
plotWin4 = widget_draw(base1,xsize = winxsize,ysize = winysize)
plotWin2 = widget_draw(base2,xsize = winxsize,ysize = winysize,$
                       event_pro = 'imageSlicerwin2draw',/button_events)
plotWin3 = widget_draw(base2,xsize = winxsize,ysize = winysize)
void = widget_button(filemenu,value = 'Exit',event_pro = 'imageSlicerQuit')

ctrlBase = widget_base(tlb,/row,/align_right)

cBase1 = widget_base(ctrlBase,/col,/align_right)
cBase2 = widget_base(ctrlBase,/col,/align_right)
cBase3 = widget_base(ctrlBase,/col)
cBase4 = widget_base(ctrlBase,/col)

ipix = cw_field(cBase1,title = 'I',value = '0',xsize = 15)
cBase5 = widget_base(cBase1,/col,/nonexclusive)
trans = widget_button(cBase5,value = 'Transpose',event_pro = 'isTranspose')
xpix = cw_field(cBase2,title = 'nx',value = '0',xsize = 3)
ypix = cw_field(cBase2,title = 'ny',value = '0',xsize = 3)

xbins = cw_field(cBase3,title = 'x-binwidth (pixels)',value = '1',xsize = 5,$
           /return_events)
ybins = cw_field(cBase3,title = 'y-binwidth (pixels)',value = '1',xsize = 5,$
           /return_events)

imageMin = cw_field(cBase4,title = 'Image min',value = '0.0',xsize = 15,$
           /return_events)
imageMax = cw_field(cBase4,title = 'Image max',value = '1.0',xsize = 15,$
           /return_events)

centertlb,tlb1
widget_control,tlb1,/realize

window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix1 = !d.window
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix2 = !d.window
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix3 = !d.window
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix4 = !d.window
widget_control,plotWin1,get_value = winVis1
widget_control,plotWin2,get_value = winVis2
widget_control,plotWin3,get_value = winVis3
widget_control,plotWin4,get_value = winVis4

; Save the current margins for the windows
origxmargin = !x.margin
origymargin = !y.margin

; Define the margins on sides of image (specified in character units)
xmarlo = 0
xmarhi = 0
ymarlo = 0
ymarhi = 0

; redefine margins (specified in character units)
!x.margin = [xmarlo,xmarhi]
!y.margin = [ymarlo,ymarhi]

xsize = winxsize
ysize = winysize

wx = 0.25*winxsize
wy = 0.25*winysize

state = {winVis1:winVis1,$
         winVis2:winVis2,$
         winVis3:winVis3,$
         winVis4:winVis4,$
         inColors:inColors,$
         plotWin1:plotWin1,$
         plotWin2:plotWin2,$
         plotWin3:plotWin3,$
         plotWin4:plotWin4,$
         wx:wx,$
         wy:wy,$
         winsize:250,$
         winxsize:winxsize,$
         winysize:winysize,$
         winPix1:winPix1,$
         winPix2:winPix2,$
         winPix3:winPix3,$
         winPix4:winPix4,$
         xsize:xsize,$
         ysize:ysize,$
         xbins:xbins,$
         ybins:ybins,$
         imageMax:imageMax,$
         imageMin:imageMin,$
         white:255,$
         maxValue:0.0,$
         xp1:0.0,$
         yp1:0.0,$
         cxpos:-999,$
         cypos:-999,$
         mouse:0B,$
         transFlag:0,$
         ;attSlider:attSlider,$
         ;smSlider:smSlider,$
         xpix:xpix,$
         ypix:ypix,$
         ipix:ipix,$
         imax:0.0,$
         imin:0.0,$
         didb:0.0,$
         nchan:0,$
         ndet:0,$
         dataPtr:ptr_new(/allocate_heap),$
         origDataPtr:ptr_new(/allocate_heap),$
         davePtr:davePtr,$
         notifyIDs:notifyIDs}

pState = ptr_new(state,/no_copy)
widget_control,tlb1,set_uvalue = pState
if n_elements(*histPtr) gt 0 then begin
	isStuffIt,{event,id:void,top:tlb1,handler:0l}
endif
xmanager,'imageSlicer',tlb1,cleanup = 'imageSlicerCleanup'
!x.margin = origxmargin
!y.margin = origymargin
end