;$Id: trifenestra_ixbase.pro,v 1.2 2002/07/10 13:12:52 azuah Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
; -------------------------------------------------------
; |	Bottom Right Window for I vs X			|
; -------------------------------------------------------

pro oivsxDraw, event
widget_control,event.top,get_uvalue=self
self -> doupdateivsx, event
return
end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::updateivsx, _extra = _extra

	if n_elements(*self.y_bp) lt 2 then begin
		errarray = ['Error caught: No data available']
		a = dialog_message(errarray,/error)
		return
	endif

	idl_state_restore, !trifenestra.bottomPanelState

	; Set values in the IX Base
	wXMin = 'ix_xmin'
	wXMax ='ix_xmax'
	self -> widget_control, wXMin, set_value = !x.range[0]
	self -> widget_control, wXMax, set_value = !x.range[1]
	wIMin = 'ix_Imin'
	wIMax = 'ix_Imax'
	self -> widget_control, wIMin, set_value = !y.range[0]
	self -> widget_control, wIMax, set_value = !y.range[1]


	wset,self.pixmapid_bp

	if !x.range[1] eq !x.range[0] then begin
		!x.range[1] = !x.range[1] * 3d / 2d
		!x.range[0] = !x.range[0] / 2d
	endif
	if !y.range[1] eq !y.range[0] then begin
		!y.range[1] = !y.range[1] * 3d / 2d
		!y.range[0] = !y.range[0] / 2d
	endif

	plot, *self.x_bp, *self.y_bp, pos=[.23,.25,.88,.9] $
		, yran=!y.range $
		, xtitle=self.xtitle $
		, ytitle='I' $
		;, xticks=3	$
		, xran=!x.range $
		, yticks=2 $
		, psym= self.ix_plot_symbol $
		, xstyle=1 $
		, ystyle=1 $
		, _extra = _extra

	errbarxy, *self.x_bp $
		, dblarr( (size(*self.x_bp, /dimensions))[0] ) $
		, *self.y_bp $
		, *self.dy_bp $
		, thick = 1.2

	; errplot, *self.x_bp $
	;	, *self.y_bp-*self.dy_bp $
	;	, *self.y_bp+*self.dy_bp

	wset, self.bpwinid
	device $
		, copy=[0,0,self.xsize_bp,self.ysize_bp,0,0,self.pixMapid_bp]

end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::doupdateivsx, event

	; Get the bounding values.
	yminid = 'ymin'
	ymaxid = 'ymax'
	self -> widget_control,yminid,get_value=ymin
	self -> widget_control,ymaxid,get_value=ymax


	idl_state_restore, !trifenestra.bottomPanelState
	; !x = *self.bangx_bp
	; !y = *self.bangy_bp

	self.oDave -> get_range, yrange=yrange

	if ymin lt yrange[0] then ymin=yrange[0]
	if ymax gt yrange[1] then ymax=yrange[1]
	self -> widget_control,yminid,set_value=ymin
	self -> widget_control,ymaxid,set_value=ymax

	if ymin ge ymax then begin
		errarray = ['Error!!! ymin > ymax']
		a = dialog_message(errarray,/error)
		return
	endif

	self.oDave -> get, qty = qty, err = err, xdata = x, ydata = y
	ivq, x, y, qty, err, qo, rio, drio, eran=[ymin, ymax]

	; ivq, *self.q, *self.hw, *self.intensity, *self.error $
	;	, qo, rio, drio, eran=[ymin,ymax]

	*self.x_bp = qo
	*self.y_bp = rio
	*self.dy_bp = drio

	finite_idx = finite( *self.y_bp )
	min_y_bp = min( (*self.y_bp)[ finite_idx ] , max = max_y_bp )
	!trifenestra.bottomPanelState.bang_y.range = $
		[ min_y_bp, max_y_bp ]
	self -> updateivsx

return
end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::ix_xmin, event

	widget_control, event.id, get_value = xmin
	!trifenestra.bottomPanelState.bang_x.range[0] = xmin
	; (*self.bangx_bp).range[0] = xmin
	self -> updateivsx

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::ix_xmax, event

	widget_control, event.id, get_value = xmax
	!trifenestra.bottomPanelState.bang_x.range[1] = xmax
	; (*self.bangx_bp).range[1] = xmax
	self -> updateivsx

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::ix_Imin, event

	widget_control, event.id, get_value = Imin
	!trifenestra.bottomPanelState.bang_y.range[0] = Imin
	; (*self.bangy_bp).range[0] = Imin
	self -> updateivsx

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::ix_Imax, event

	widget_control, event.id, get_value = Imax
	!trifenestra.bottomPanelState.bang_y.range[1] = Imax
;	(*self.bangy_bp).range[1] = Imax
	self -> updateivsx

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;----------- Toggle to fix or release the range of Intensity
;            when the cursor on the image plot moves
pro trifenestra::fix_i_range_bpevent, event

	strings = [ 'Fix I Range', 'Release I Range' ]
	self.togirange_bp = 1 - self.togirange_bp

	; fixirange_bp = widget_info(self.tlb,find_by_uname='fixirange_bp')
	widget_control, event.id, set_value = strings[ self.togirange_bp ]

	return
end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra_IXBase, base

I_X= widget_base( base $
	, /col $
	, /frame $
	, event_pro = 'oivsxdraw' )

I_X_label = widget_label( I_X $
	, value= 'I(X)'	$
	, /align_center $
	, font='helvetica*14*bold')

I_X_xbounds = widget_base( I_X $
	, /row $
	, event_pro = 'trifenestra_event' $
	)

!trifenestra.self -> widgets, cw_field( I_X_xbounds $
	, tit='X min'	$
	, value=1. $
	, uname='ix_xmin' $
	, uvalue='ix_xmin' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

!trifenestra.self -> widgets, cw_field( I_X_xbounds $
	, tit='X max'	$
	, value=1. $
	, uname='ix_xmax' $
	, uvalue='ix_xmax' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

I_X_ybounds = widget_base( I_X $
	, /row $
	)

!trifenestra.self -> widgets, cw_field( I_X_ybounds $
	, tit='Y min'	$
	, value=1. $
	, uname='ymin' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

!trifenestra.self -> widgets, cw_field( I_X_ybounds $
	, tit='Y max'	$
	, value=1. $
	, uname='ymax' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

I_X_Ibounds = widget_base( I_X $
	, /row $
	, event_pro = 'trifenestra_event' $
	)

!trifenestra.self -> widgets, cw_field( I_X_Ibounds $
	, tit='I min'	$
	, value=1. $
	, uname='ix_Imin' $
	, uvalue='ix_Imin' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

!trifenestra.self -> widgets, cw_field( I_X_Ibounds $
	, tit='I max'	$
	, value=1. $
	, uname='ix_Imax' $
	, uvalue='ix_Imax' $
	, /column $
	, xsize = 7 $
	, /return_events $
	, /floating)

; fixibase_bp = widget_base(ivsxbase,/nonexclusive)

; self.togirange_bp = 'Fix I Range'
!trifenestra.self -> widgets, widget_button( I_X $
	, value= 'Fix I Range' $
	, uname='fixirange_bp' $
	, uvalue = 'fix_i_range_bpevent' $
	, event_pro='trifenestra_event')

	return, I_X

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************